function [hv]=hypervolume(ROS,r,S)
if nargin<2
    r=max(ROS);
end
if nargin<3
    N=10^5;
    z=zeros(1,size(ROS,2));
    % z=min(ROS)-0.1;
    rng=r-z;
    R=diag(rng);
    Z=repmat(z,N,1);
    S=Z+rand(N,size(ROS,2))*R;
    S(1,:)=r; % always use r as a member of S
end
N=size(S,1);
stat=zeros(size(ROS,1),N);
stat_total=zeros(1,N);
for j=1:N
    temp=S(j,:);
    for i=1:size(ROS,1)
        stat(i,j)=pareto_dominate(ROS(i,:),temp);
        % Note: stat(i,j)=1 iff ROS(i,:) dominates S(j,:)
        stat_total(j)=or(stat_total(j),stat(i,j));
        if stat_total(j)==1  % if atleast one candidate of ROS
            break;    % dominates a point from S
        end
    end
end
Num=sum(stat_total);
hv=Num/N;
end





















