function [IDX, n_components] = decision_space_clustering(Pop, eps)
popsize = size(Pop, 1);
[W, ~] = nearest_neighbor_graph(Pop, eps);
% disp('W = ');
% disp(W);

W_sum = sum(W);
if sum(W_sum) == 0
    n_components = 1;
else
    D = diag(W_sum);
    Lsym = eye(popsize) - sqrt(inv(D)) * W * sqrt(inv(D));
    % disp('Lsym = ');
    % disp(Lsym);
    [eigen_vector, eigen_values] = eig(Lsym);
    n_components = sum(abs(diag(eigen_values)) < 10^-8);
end

if n_components ~= 1
    IDX = kmeans(eigen_vector(:, 2:n_components), n_components);
else
    IDX = ones(popsize, 1);
end
end