function idx = diversity(DS, OS)
[NP, n_obj] = size(OS);
[~, n_vars] = size(DS);
if NP < 3
    idx = 1:NP;
else
    idx = 1:NP;
    CDf = zeros(NP, 1);
    CDx = zeros(NP, 1);
    SCD = zeros(NP, 1);
    for j = 1:n_obj % crowding distance in objective space
        [~, In] = sort(OS(:, j));
        OS = OS(In, :); DS = DS(In, :); idx = idx(In); CDf = CDf(In, :);
        CDf(1, 1) = CDf(1, 1) + 1;
        CDf(NP, 1) = CDf(NP, 1) + 0;
        fmin = OS(1, j); fmax = OS(NP, j);
        if fmax ~= fmin
            for i = 2 : NP - 1
                CDf(i) = CDf(i) + abs(OS(i + 1, j) - OS(i - 1, j)) / abs(fmax - fmin);
            end
        else
            for i = 2 : NP - 1
                CDf(i) = CDf(i) + 1;
            end
        end        
    end
    for j = 1:n_vars % crowding distance in decision space
        [~, In] = sort(DS(:, j));
        OS = OS(In, :); DS = DS(In, :); idx = idx(In); CDf = CDf(In, :); CDx = CDx(In, :);
        xmin = DS(1, j); xmax = DS(NP, j);
        if xmax ~= xmin
            CDx(1, 1) = CDx(1, 1) + abs(DS(1, j) - DS(2, j)) / abs(xmax - xmin);
            CDx(NP, 1) = CDx(NP, 1) + abs(DS(NP, j) - DS(NP - 1, j)) / abs(xmax - xmin);
            for i = 2 : NP - 1
                CDx(i) = CDx(i) + abs(DS(i + 1, j) - DS(i - 1, j)) / abs(xmax - xmin);
            end
        else
            for i = 1 : NP
                CDx(i) = CDx(i) + 1;
            end
        end        
    end
    CDf_avg = mean(CDf); CDx_avg = mean(CDx);
    for j = 1 : NP % special crowding distance
        if CDf(j, 1) > CDf_avg || CDx(j, 1) > CDx_avg
            SCD(j, 1) = max([CDx(j,1), CDf(j, 1)]);
        else
            SCD(j, 1) = min([CDx(j,1), CDf(j, 1)]);
        end
    end
    [~, In] = sort(SCD,'descend');
    idx = idx(In);
end
end