function new_arch = selection_lord2(arch, flag)
% 1. select the subpopulation with > 1 candidate having highest pbi
pop_index = 1:arch.size;
n_dir = size(arch.ref_dir, 1);
worst_scalar_fit = zeros(n_dir, 1); worst_scand = zeros(n_dir, 1);
for dir_i = 1:n_dir
    region_i_size = length(pop_index(arch.assoc_dir == dir_i));
    if region_i_size > 1
        this_subpop_index = pop_index(arch.assoc_dir == dir_i);
        this_subpop = choose_candidate(arch, this_subpop_index);
%         disp(this_subpop.dec);
%         [worst_scalar_fit(dir_i, 1), worst_scand(dir_i, 1)] = max(this_subpop.scalar_fit, [], 1);
        [worst_scalar_fit(dir_i, 1), in] = max(this_subpop.scalar_fit, [], 1);
        worst_scand(dir_i, 1) = this_subpop_index(in);
    end
%     if region_i_size <= 6
%         worst_scalar_fit(dir_i, 1) = 0;
%     end
end
[~, new_assoc_dir] = max(worst_scalar_fit, [], 1);
% sub_pop_index = pop_index(arch.assoc_dir == new_assoc_dir);
% subpop = choose_candidate(arch, sub_pop_index);
% worst_cand = sub_pop_index(worst_scand(new_assoc_dir));
worst_cand = worst_scand(new_assoc_dir);
if flag == 0
    % 5. Final selection to delete worst_cand
    good_index = ones(arch.size, 1);
%     disp(worst_cand);
    good_index(worst_cand, 1) = 0; % remove the worst cand
    good_index = logical(good_index);
    new_arch = choose_candidate(arch, good_index); % selection
elseif flag == 1
%     [new_arch, ~] = environmental_selection(arch, arch.size - 1);
%     visualize_MMOPs(subpop);

    % 2. spectral clustering the decision space
%     n_obj = size(arch.obj, 2);
%     al = 0.5/(1+exp(-sign(n_obj-4)*0.05*n_obj^2));
%     eps = al * sqrt(sum((max(arch.dec) - min(arch.dec)).^2));
    eps = 0.2 * sqrt(sum((max(arch.dec) - min(arch.dec)).^2));
%     eps = 0.2 * sqrt(sum((arch.XU - arch.XL).^2));
    [IDX, n_components] = decision_space_clustering(arch.dec, eps);
    if n_components > 1 
        % 3. Number of candidates within each component
        size_Ci = zeros(1, n_components);
        for Ci = 1 : n_components
            size_Ci(1, Ci) = sum(IDX == Ci);
        end
    
        % 4. Among the candidates having worst pbi, select the component 
        % having highest number of candidates
        comp_worst_scand = IDX(worst_scand(worst_scand ~= 0));
        comp_to_check = unique(comp_worst_scand);
        size_worst_comp = zeros(1, n_components);
        size_worst_comp(1, comp_to_check) = size_Ci(1, comp_to_check);
        [~, comp_with_max_ncand] = max(size_worst_comp, [], 2);
    
        % 5. Select the cand from comp with max candidates and then select
        % cand with highest pbi
        index_with_max_ncand = pop_index(IDX == comp_with_max_ncand);
        worst_cands_id = intersect(worst_scand, index_with_max_ncand);
        worst_cands = choose_candidate(arch, worst_cands_id);
        [~, in] = max(worst_cands.scalar_fit, [], 1);
        worst_cand = worst_cands_id(in);
    end
    % 6. Final selection to delete worst_cand
    good_index = ones(arch.size, 1);
    good_index(worst_cand, 1) = 0; % remove the worst cand
    good_index = logical(good_index);
    new_arch = choose_candidate(arch, good_index); % selection    
end
end