function visualize_MMOPs(arch)
n_obj = size(arch.obj, 2);
cand_dim = size(arch.dec, 2);
if n_obj == 2 && cand_dim == 2
    [~, in] = sort(arch.obj(:, 1));
    DS = arch.dec(in, :);
    OS = arch.obj(in, :);
    figure;
    for i = 1 : size(arch.obj, 1)
        gl = i * 0.7 / size(arch.obj, 1);
        title('Decision Space');
        plot(DS(i, 1), DS(i, 2), 'o', 'markerfacecolor', [gl, gl, gl], 'markeredgecolor', [gl, gl, gl]);
        hold on;
    end
    axis([arch.XL(1) arch.XU(1) arch.XL(2) arch.XU(2)]);
    figure;
    for i = 1 : size(arch.obj, 1)
        gl = i * 0.7 / size(arch.obj, 1);
        title('Objective Space');
        plot(OS(i, 1), OS(i, 2), 'o', 'markerfacecolor', [gl, gl, gl], 'markeredgecolor', [gl, gl, gl]); 
        hold on;
    end
    axis([0 arch.ref_pt(1) 0 arch.ref_pt(2)]);
elseif n_obj == 2 && cand_dim == 3
    [~, in] = sort(arch.obj(:, 1));
    DS = arch.dec(in, :);
    OS = arch.obj(in, :);
    figure;
    for i = 1 : size(arch.obj, 1)
        gl = i * 0.7 / size(arch.obj, 1);
        title('Decision Space');
        scatter3(DS(i, 1), DS(i, 2), DS(i,3), 'o', 'markerfacecolor', [gl, gl, gl], 'markeredgecolor', [gl, gl, gl]);
        hold on;
    end
    figure;
    for i = 1 : size(arch.obj, 1)
        gl = i * 0.7 / size(arch.obj, 1);
        title('Objective Space');
        plot(OS(i, 1), OS(i, 2), 'o', 'markerfacecolor', [gl, gl, gl], 'markeredgecolor', [gl, gl, gl]); 
        hold on;
    end
elseif n_obj == 3 && cand_dim == 3
    figure; scatter3(arch.dec(:, 1), arch.dec(:, 2), arch.dec(:, 3)); title('Decision Space');
    figure; scatter3(arch.obj(:, 1), arch.obj(:, 2), arch.obj(:, 3)); title('Objective Space');
else
    return;
end
% saveas(gcf,['Results/', arch.problem, '.jpg']);
end